#!/usr/bin/perl

# WARNING
# This script is unsupported.
#
# If you use this script or a program derived from it you should test extensively and limit the scope of urls that 

# MANDATORY STEPS
# 1) httpd.conf:
# RewriteMap utf8map prg:/opt/nlsMap.pl
# RewriteLock /opt/IHS/logs/rewrite.lock
# Rewrite Cond ....
# RewriteMap (.*) ${utf8map:$1}
# 2) Add mappings from utf8->local charset to hash below
# 3) Test (you can also test on the command line by creating a file full of URLS and redirecting it in.
# 4) Remove/Edit logging (default: /tmp/nls.log). 

# are run through this RewriteMap.  Consider per-directory or RewriteCond.
# If the URL is a valid UTF-8 string, replace hash keys with hash values, else return the original string.
# When we see invalid UTF-8 we assume the contained some local codepage w/ characters of ordinal greater than 127.

# Testing hint; curl http;//host`echo -e '\xC3\xA3'`/.html
# When we log something like a bad continuation character, that's a sign that the request was in some local codepage

use strict;

# Turn off buffering for stdout
$| = 1;

my ($retvalue, $LOG);

# EDIT HERE -- EXAMPLES ARE NOT WHAT YOU WANT!
# Format: UTF-8 Bytes ... => Local Codepage Byte
my %hash = (
    chr(0xC3) . chr(0xA3) => chr(0xE3),
    chr(0xE0) . chr(0xA4) . chr(0xB1) => chr(0xE4),
);

setupLog();

# The main loop that responds to mod_rewrite
while(<STDIN>) {
    $retvalue = detect_utf8($_); 
    chomp;
    print LOG "$_ => $retvalue" ;
    print $retvalue;
}

print LOG "End \n";


sub detect_utf8() {

    my $url = shift @_;
    my @chars = split(//, $url);
    my $i = 0;
    my ($ch, $ch_ord, $newch, $expect, $mask);
    my $retvalue = "";

    for ($i=0; $i <= $#chars;  )
    {
        $ch = $chars[$i++];
        $ch_ord = ord($ch);

        if (!($ch_ord & 0200)) {
          # Low Ascii
          $retvalue  .= $ch;
        }
        else
        {
            if (($ch_ord & 0300) != 0300) {
                # continuation out of place
		print LOG "Continuation character out of place\n";
                return $url;
            }
            else
            {
                # Multibyte Sequence Lead Character
                # Compute the expected bytes while adjusting
                # or lead byte and leading zeros mask.
                #
                $mask = 0340;
                $expect = 1;
                while (($ch_ord & $mask) == $mask) {
                    $mask |= $mask >> 1;
                    if (++$expect > 3) {
                        print LOG "Too many continuations\n";
                        return $url;
                    }
                }
                $newch = $ch_ord & ~$mask;
                # Reject values of excessive leading 0 bits
                # utf-8 _demands_ the shortest possible byte length
                #
                print LOG "Expect =$expect\n";
                if ($expect == 1) {
                    if (!($newch & 0036)) {
                        print LOG "Not shortest utf-8 encoding\n";
                        return $url;
                    }
                }
                else {
                    # Reject values of excessive leading 0 bits
                    if (!$newch && !(ord($chars[$i]) & 0077 & ($mask << 1))) {
                        print LOG "Not shortest utf-8 encoding\n";
                        return $url;
                    }
                    if ($expect == 2) {
                        # Reject values D800-DFFF when not utf16 encoded
                        # (may not be an appropriate restriction for ucs-4)
                        # 
                        if ($newch == 0015 && (ord($chars[$i]) & 0040)){
                            print LOG "D800-DFFF\n";
                            return $url;
                        }
                    }
                    elsif ($expect == 3) {
                        # Short circuit values > 110000
                        if ($newch > 4) {
                            print LOG "Bad Sequence\n";
                            return $url;
                        }
                        if ($newch == 4 && (ord($chars[$i]) & 0060)) {
                            print LOG "Bad Sequence\n";
                            return $url;
                        }
                    }
                }
                my $total = $ch;
                while ($expect--)
                {
                    # Multibyte Continuation must be legal */
                    $ch = $chars[$i++]; 
                    $ch_ord = ord($ch);
                    $total = $total  . $ch;
                    if ( ($ch_ord & 0300) != 0200) {
                        print LOG "Wrong continuation";
                        return $url;
                    }
                }
              if (defined $hash{$total}) {
                    print LOG "Got a match changeing seq $total to $hash{$total}\n";
                    $retvalue .= $hash{$total};
              }
              else {
                    # Put the UTF-8 sequence back
                    $retvalue .= $total;
              }
            }
        }
    }
return $retvalue;
}

sub setupLog() {
    # Turn off buffering for logfile
    my $ofh = select LOG;
    $| = 1;
    select $ofh;
    open LOG, ">> /tmp/nls.log" or die "can't open logfile: $!"; 
    print LOG "Begin\n";
}
